// #autoload
// #name = FlagBox
// #version = 1.5
// #date = 16 February, 2003
// #author = ilys
// #description = Two coloured boxes, one for each team. Changes colour, from green(home) to red(taken) and flashes red/green(dropped).
// #category = ilys' Scripts
// #credits = Kaiten for the Tag lookup code
// #status = release
// #include = support/callback.cs
// #include = support/flag_tracker.cs
// #include = support/player_support.cs
// #include = support/mission_callbacks.cs
// #include = support/tourney_mode.cs

package FlagBox {
function PlayGui::onWake(%this) {
	callback.add(onCTFGrab, FlagBoxFlagTaken);
	callback.add(onCTFCap, FlagBoxFlagReturn);
	callback.add(onCTFDrop, FlagBoxFlagDrop);
	callback.add(onCTFPicked, FlagBoxFlagTaken);
	callback.add(onCTFReturn, FlagBoxFlagReturn);
	callback.add(onMatchStart, FlagBoxMatchStart);
	callback.add(onMissionEnd, FlagBoxMissionEnd);
	callback.add(onGameOver, FlagBoxMissionEnd);
	callback.add(MyTeamChanged, FlagBoxTeamChange);
	callback.add(onUserClientDrop, FlagBoxDrop);
	parent::onWake(%this);

	if(!isObject(PlayGui)) return;

	if (isObject(FlagBox)) return;

	new GuiControlProfile ("CenterTextProfile")
	{
		fontType = "Univers Condensed";
		fontSize = 16;
		fontColor = "66 229 244";
		justify = "center";
	};

	new ShellFieldCtrl(FlagBox) {
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 500";
		extent = "74 57";
		visible = "1";
		new GuiMLTextCtrl(YourTeamName) {
			profile = "CenterTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "37 20";
			visible = "1";
		};
		new HudBitmapCtrl(yourcolourbox) {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 20";
			extent = "37 37";
			fillcolor = "0.000000 1.000000 0.000000 1.000000";
			frameColor = "0.000000 1.000000 0.000000 1.000000";
			opacity = "1";
			visible = "1";
		};
		new GuiMLTextCtrl(EnemyTeamName) {
			profile = "CenterTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "37 0";
			extent = "37 20";
			visible = "1";
		};
		new HudBitmapCtrl(enemycolourbox) {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "37 20";
			extent = "37 37";
			fillcolor = "0.000000 1.000000 0.000000 1.000000";
			frameColor = "0.000000 1.000000 0.000000 1.000000";
			opacity = "1";
			visible = "1";
		};
	};
	playGui.add(FlagBox);
	YourTeamName.setValue(teamTracker.teamName[1]);
	EnemyTeamName.setValue(teamTracker.teamName[2]);
	if(isObject(HM) && isObject(HudMover)) hudmover::addhud(FlagBox,"FlagBox");
}

function FlagBoxFlagDrop(%flagref)
{
	%myname = PlayerList.getMyName();
	%myteam = PlayerList.getTeamByName(%myname);
	%flagteam = %flagref.teamID;
	if(%myteam != 0)
	{
		if(%flagteam == %myteam)
		{
			yourcolorswapcycle();
		}
		if(%flagteam != %myteam)
		{
			enemycolorswapcycle();
		}
	}
	else if(%myteam == 0)
	{
		%myteam = 1;
		if(%flagteam == %myteam)
		{
			yourcolorswapcycle();
		}
		if(%flagteam != %myteam)
		{
			enemycolorswapcycle();
		}
	}
}

function FlagBoxFlagTaken(%flagref)
{
	%myname = PlayerList.getMyName();
	%myteam = PlayerList.getTeamByName(%myname);
	%flagteam = %flagref.teamID;
	if(%myteam != 0)
	{
		if(%flagteam == %myteam)
		{
			if ($yourcolorswapSchedule != 0) cancel($yourcolorswapSchedule);
			yourcolourbox.fillcolor = "1.000000 0.000000 0.000000 1.000000";
			yourcolourbox.framecolor = "1.000000 0.000000 0.000000 1.000000";
		}
		if(%flagteam != %myteam)
		{
			if ($enemycolorswapSchedule != 0) cancel($enemycolorswapSchedule);
			enemycolourbox.fillcolor = "1.000000 0.000000 0.000000 1.000000";
			enemycolourbox.framecolor = "1.000000 0.000000 0.000000 1.000000";
		}
	}
	else if(%myteam == 0)
	{
		%myteam = 1;
		if(%flagteam == %myteam)
		{
			if ($yourcolorswapSchedule != 0) cancel($yourcolorswapSchedule);
			yourcolourbox.fillcolor = "1.000000 0.000000 0.000000 1.000000";
			yourcolourbox.framecolor = "1.000000 0.000000 0.000000 1.000000";
		}
		if(%flagteam != %myteam)
		{
			if ($enemycolorswapSchedule != 0) cancel($enemycolorswapSchedule);
			enemycolourbox.fillcolor = "1.000000 0.000000 0.000000 1.000000";
			enemycolourbox.framecolor = "1.000000 0.000000 0.000000 1.000000";
		}
	}
}

function FlagBoxFlagReturn(%flagref)
{
	%myname = PlayerList.getMyName();
	%myteam = PlayerList.getTeamByName(%myname);
	%flagteam = %flagref.teamID;
	if(%myteam != 0)
	{
		if(%flagteam == %myteam)
		{
			if ($yourcolorswapSchedule != 0) cancel($yourcolorswapSchedule);
			yourcolourbox.fillcolor = "0.000000 1.000000 0.000000 1.000000";
			yourcolourbox.framecolor = "0.000000 1.000000 0.000000 1.000000";
		}
		if(%flagteam != %myteam)
		{
			if ($enemycolorswapSchedule != 0) cancel($enemycolorswapSchedule);
			enemycolourbox.fillcolor = "0.000000 1.000000 0.000000 1.000000";
			enemycolourbox.framecolor = "0.000000 1.000000 0.000000 1.000000";
		}
	}
	else if(%myteam == 0)
	{
		%myteam = 1;
		if(%flagteam == %myteam)
		{
			if ($yourcolorswapSchedule != 0) cancel($yourcolorswapSchedule);
			yourcolourbox.fillcolor = "0.000000 1.000000 0.000000 1.000000";
			yourcolourbox.framecolor = "0.000000 1.000000 0.000000 1.000000";
		}
		if(%flagteam != %myteam)
		{
			if ($enemycolorswapSchedule != 0) cancel($enemycolorswapSchedule);
			enemycolourbox.fillcolor = "0.000000 1.000000 0.000000 1.000000";
			enemycolourbox.framecolor = "0.000000 1.000000 0.000000 1.000000";
		}
	}
}

function yourcolorswapcycle()
{
	if($yourcolorswap == 1)
	{
		yourcolourbox.fillcolor = "1.000000 0.000000 0.000000 1.000000";
		yourcolourbox.framecolor = "1.000000 0.000000 0.000000 1.000000";
		$yourcolorswap = 0;
	}
	else
	{
		yourcolourbox.fillcolor = "0.000000 1.000000 0.000000 1.000000";
		yourcolourbox.framecolor = "0.000000 1.000000 0.000000 1.000000";
		$yourcolorswap = 1;
	}

	$yourcolorswapSchedule = schedule(500, 0, yourcolorswapcycle);
}

function enemycolorswapcycle()
{
	if($enemycolorswap == 1)
	{
		enemycolourbox.fillcolor = "1.000000 0.000000 0.000000 1.000000";
		enemycolourbox.framecolor = "1.000000 0.000000 0.000000 1.000000";
		$enemycolorswap = 0;
	}
	else
	{
		enemycolourbox.fillcolor = "0.000000 1.000000 0.000000 1.000000";
		enemycolourbox.framecolor = "0.000000 1.000000 0.000000 1.000000";
		$enemycolorswap = 1;
	}

	$enemycolorswapSchedule = schedule(500, 0, enemycolorswapcycle);
}

function FlagBoxMatchStart()
{
	%myname = PlayerList.getMyName();
	%myteam = PlayerList.getTeamByName(%myname);
	if($TourneyMode)
	{
		FlagBoxTeamChange(%myteam);
	}
}

function FlagBoxMissionEnd()
{
	if ($yourcolorswapSchedule != 0) cancel($yourcolorswapSchedule);
	if ($enemycolorswapSchedule != 0) cancel($enemycolorswapSchedule);
	yourcolourbox.fillcolor = "0.000000 1.000000 0.000000 1.000000";
	yourcolourbox.framecolor = "0.000000 1.000000 0.000000 1.000000";
	enemycolourbox.fillcolor = "0.000000 1.000000 0.000000 1.000000";
	enemycolourbox.framecolor = "0.000000 1.000000 0.000000 1.000000";
}

function FlagBoxDrop(%clientName, %clientID)
{
	if ($yourcolorswapSchedule != 0) cancel($yourcolorswapSchedule);
	if ($enemycolorswapSchedule != 0) cancel($enemycolorswapSchedule);
	if (isObject(FlagBox))
	{
		playGui.remove(FlagBox);
		FlagBox.delete();
	}
}

function FlagBoxGetTeamTags(%getteamID)
{
	$bestTag[1] = "";
	$bestTag[2] = "";
	commandToServer('getScores');
	%count = PlayerListGroup.getCount();
	for(%i = 0; %i < %count; %i++)
	{
		%obj = PlayerListGroup.getObject(%i);
		if ( !%obj.isSmurf )
		{
			%name = %obj.name;
			%teamid = %obj.teamId;
			%pos1 = strStr(%name, "\c6");
			if(%pos1 > 0)
			{
				%pos2 = strStr(%name, "\c7");
				if(%pos2 < %pos1)
				{
					%Tag = getSubStr(%name, %pos2 + 1, %pos1 - %pos2 - 1);
				}
				else
				{
					%pos3 = strStr(%name, "\x11");
					%Tag = getSubStr(%name, %pos2 + 1, %pos3 - %pos2 - 1);
				}
			}
			if ( %Tag !$= "" )
			{
 				%tagCounts[%teamid, %Tag]++;
				if ( %tagCounts[%teamid, %Tag] > %bestTagCount[%teamid] )
				{
  					%bestTagCount[%teamid] = %tagCounts[%teamid, %Tag];
  					$bestTag[%teamid] = %Tag;
				}
			}
		}
	}
	return $bestTag[%getteamID];
}

function FlagBoxTeamChange(%teamID)
{
	if ($yourcolorswapSchedule != 0) cancel($yourcolorswapSchedule);
	if ($enemycolorswapSchedule != 0) cancel($enemycolorswapSchedule);
	yourcolourbox.fillcolor = "0.000000 1.000000 0.000000 1.000000";
	yourcolourbox.framecolor = "0.000000 1.000000 0.000000 1.000000";
	enemycolourbox.fillcolor = "0.000000 1.000000 0.000000 1.000000";
	enemycolourbox.framecolor = "0.000000 1.000000 0.000000 1.000000";
	if(%teamID != 0)
	{
		%myteam = %teamID;
		if(%myteam == 1)
			%enemyteam = 2;
		else
			%enemyteam = 1;

		%myflag = FlagTracker.team[%myteam];
		%enemyflag = FlagTracker.team[%enemyteam];
		FlagBoxGetTeamTags(1);
		FlagBoxGetTeamTags(2);
		if($TourneyMode)
		{
			%myteamtag = FlagBoxGetTeamTags(%myteam);
			%enemyteamtag = FlagBoxGetTeamTags(%enemyteam);
			YourTeamName.setValue(%myteamtag);
			EnemyTeamName.setValue(%enemyteamtag);
		}
		else
		{
			YourTeamName.setValue("Ours");
			EnemyTeamName.setValue("Theirs");
		}
		if(%myflag.stateCurrent $= "At Home")
		{
			yourcolourbox.fillcolor = "0.000000 1.000000 0.000000 1.000000";
			yourcolourbox.framecolor = "0.000000 1.000000 0.000000 1.000000";
		}
		else if(%myflag.stateCurrent $= "Taken")
		{
			yourcolourbox.fillcolor = "1.000000 0.000000 0.000000 1.000000";
			yourcolourbox.framecolor = "1.000000 0.000000 0.000000 1.000000";
		}
		else if(%myflag.stateCurrent $= "In Field")
		{
			yourcolorswapcycle();
		}
		if(%enemyflag.stateCurrent $= "At Home")
		{
			enemycolourbox.fillcolor = "0.000000 1.000000 0.000000 1.000000";
			enemycolourbox.framecolor = "0.000000 1.000000 0.000000 1.000000";
		}
		else if(%enemyflag.stateCurrent $= "Taken")
		{
			enemycolourbox.fillcolor = "1.000000 0.000000 0.000000 1.000000";
			enemycolourbox.framecolor = "1.000000 0.000000 0.000000 1.000000";
		}
		else if(%enemyflag.stateCurrent $= "In Field")
		{
			enemycolorswapcycle();
		}
	}
	else if(%teamID == 0)
	{
		%myteam = 1;
		%myflag = FlagTracker.team[%myteam];

		%enemyteam = 2;
		%enemyflag = FlagTracker.team[%enemyteam];
		FlagBoxGetTeamTags(1);
		FlagBoxGetTeamTags(2);
		if($TourneyMode)
		{
			%myteamtag = FlagBoxGetTeamTags(%myteam);
			%enemyteamtag = FlagBoxGetTeamTags(%enemyteam);
			YourTeamName.setValue(%myteamtag);
			EnemyTeamName.setValue(%enemyteamtag);
		}
		else
		{
			YourTeamName.setValue(teamTracker.teamName[%myteam]);
			EnemyTeamName.setValue(teamTracker.teamName[%enemyteam]);
		}

		if(%myflag.stateCurrent $= "At Home")
		{
			yourcolourbox.fillcolor = "0.000000 1.000000 0.000000 1.000000";
			yourcolourbox.framecolor = "0.000000 1.000000 0.000000 1.000000";
		}
		else if(%myflag.stateCurrent $= "Taken")
		{
			yourcolourbox.fillcolor = "1.000000 0.000000 0.000000 1.000000";
			yourcolourbox.framecolor = "1.000000 0.000000 0.000000 1.000000";
		}
		else if(%myflag.stateCurrent $= "In Field")
		{
			yourcolorswapcycle();
		}
		if(%enemyflag.stateCurrent $= "At Home")
		{
			enemycolourbox.fillcolor = "0.000000 1.000000 0.000000 1.000000";
			enemycolourbox.framecolor = "0.000000 1.000000 0.000000 1.000000";
		}
		else if(%enemyflag.stateCurrent $= "Taken")
		{
			enemycolourbox.fillcolor = "1.000000 0.000000 0.000000 1.000000";
			enemycolourbox.framecolor = "1.000000 0.000000 0.000000 1.000000";
		}
		else if(%enemyflag.stateCurrent $= "In Field")
		{
			enemycolorswapcycle();
		}
	}
}
};
activatePackage(FlagBox);